import time
from DownloadHelper import download_ytdlp, download_tiktok_video
from SourceDataHelper import process_video_sd
import requests

URL_HOME="https://moonseo.app"
URL_GET_JOB=f"{URL_HOME}/api/source/data/crawl"
URL_UPDATE_JOB=f"{URL_HOME}/api/source/data/update-by-id"
headers={"platform":"autowin"}


def execute():
    print("crawling: "+str(time.time()))
    obj = requests.get(URL_GET_JOB, headers=headers).json()
    if "id" in obj:
        print("Process: "+str(obj['id']))
        video_path = None
        if obj['platform'] =='tiktok':
            video_path = download_tiktok_video(obj['ori_link'])
        if obj['platform'] =='youtube':
            video_path = download_ytdlp(obj['ori_link'])
        sc_new = process_video_sd(video_path)
        if not sc_new:
            sc_new={"id": obj['id']}
            if(obj['crawl_retries']<3):
                sc_new['crawl_retries']=obj['crawl_retries']+1
                sc_new['status'] = 1 #retries
            else:
                sc_new['status'] = 4
        else:
            sc_new['status'] = 3
        rs=requests.post(URL_UPDATE_JOB, json=sc_new, headers=headers).json()
        print(rs)

